<template>
    <div class="login-app">
        <div v-bind:class="[error.show? 'active-message': '' ,'info-messages']">
            <p>{{ error.message  }}</p>
        </div>
        <div class="login-form">
            <div class="top-login">
                <!--<img src="assets/logo-messoft.png " alt="">-->
                <h1>JIRA Stopwatch - Sign in</h1>
            </div>
            <div class="form" >
                <input class="login-fields" v-on:keyup.enter="login" v-model="hostname"  type="text" name="hostname"  required placeholder="Jira URL">
                <input class="login-fields" v-on:keyup.enter="login" v-model="credentials.username"  type="text" name="username"  required placeholder="Username">
                <input class="login-fields" v-on:keyup.enter="login" v-model="credentials.password"   type="password" name="password"  required placeholder="Password">
                <input class="submit-button" v-on:click="login" type="submit" value="Sign in">
            </div>


        </div>
    </div>
</template>

<script>
    const {ipcRenderer} = window.require('electron')
export default {
      data: function () {
        return {
          credentials: {username: '', password: ''},
          hostname: '',
          error: {show: false, message: ''}
        }
      },
      methods: {
        login: function () {
          let loginParameters = {
            credentials: this.credentials,
            hostname: this.hostname
          }
          ipcRenderer.send('login', loginParameters)
        }
      },
      created: function () {
        ipcRenderer.send('init-login')
        ipcRenderer.on('initialize-login', (event, arg) => {
          this.hostname = arg
        })


        ipcRenderer.send('check-credentials')

        ipcRenderer.on('bypass-login', (event, arg) => {
          this.$router.push('timer')
        })
        ipcRenderer.on('login-success', (event, arg) => {
          this.$router.push('timer')
        })
        ipcRenderer.on('login-failed', (event, arg) => {
          let self = this
            console.log(arg)
          switch (arg.status){
              case 401:
                  self.error.show = true
                  self.error.message = 'Unauthorized access'
                  break
              default:
                  if(arg.hasOwnProperty('data') && arg.data.hasOwnProperty('errorMessages')){
                      self.error.message = arg.data.errorMessages[0];
                  }else{
                      self.error.message = 'Failed to connect with JIRA';
                  }
                  self.error.show = true
          }
          setTimeout(function () {
            if (self.error.show === true) { self.error.show = false }
          }, 2000)
          console.log(arg)
        })
      },
      name: 'login-page'
    }

</script>

<style scoped lang="scss">
    @import url('https://fonts.googleapis.com/css?family=Dancing+Script');
    $roboto: 'Roboto', sans-serif;

    .active-message{
        top:0 !important;
        transition: linear .5s;
    }

    .active-task{
        bottom:50px !important;
        transition: linear .5s;
    }

    .text{
        font-family: $roboto;
        font-size: 16px;
        color:#888;
    }
    .regular{
        font-family: $roboto;
        font-size: 14px;
        margin:0;
    }
    .small{
        font-family: $roboto;
        font-size: 12px;
        color:#888;
        margin:0;
    }

    .login-app{
        overflow: hidden;
        height: 100vh;
        width: 100%;
        background: #fbfbfb;
        display:flex;
        align-items:center;
        position: relative;
        .info-messages{
            width: 100%;
            height: 25px;
            position: absolute;
            top:-26px;
            color:#EEE;
            background: #f07762;
            border-bottom: 1px solid #eee;
            text-align: center;
            transition:all .5s;
            p{
                line-height: 25px;
                @extend .regular;

            }

        }
        .login-form{
            width: 100%;
            display: flex;
            flex-direction: column;
            padding: 0 60px;
            .top-login{
                h1{
                    font-size: 20px;
                    font-weight: 300;
                    color:#888;
                    text-align: left;
                }
            }
            .form{
                input{
                    background: transparent;
                    border:none;
                    display: block;
                    width: 100%;
                    height: 40px;
                    margin: 8px 0;
                    border: 1px solid rgba(#888,.5%);
                    border-radius: 5px;

                    text-indent:5px;
                    font-family: $roboto;
                    font-size: 14px;
                    color:#888;

                    &::-webkit-input-placeholder { /* Chrome/Opera/Safari */
                        color:#DDD;
                    }

                }
                input[type="submit"]{
                    /*max-width: 150px;*/
                    width: 100%;
                    margin: auto;
                    display: flex;
                    justify-content: center;
                    color:#EEE;
                    width: 100%;
                    height: 35px;
                    border: none;
                    background: lighten(#ec4f33,10%);
                    border-radius: 5px;
                    transition:all .3s;
                    cursor:pointer;
                    &:hover{
                        background:lighten(#ec4f33,13%);
                        transition:all .3s;
                    }
                }
            }

        }
    }
</style>
